import 'package:anadea_flutter_loggy/anadea_flutter_loggy.dart';
import 'package:flutter/material.dart';
import 'package:loggy/loggy.dart';

/// Used for bloc records list on the [LogsScreen]
class BlocRecordCard extends StatelessWidget {
  BlocRecordCard({
    Key? key,
    required this.logRecord,
  })  : assert(logRecord.object is BlocLogRecord),
        super(key: key);

  /// Must contains [BlocLogRecord] in the [LogRecord.object] field
  final LogRecord logRecord;

  @override
  Widget build(BuildContext context) {
    final blocRecord = logRecord.object as BlocLogRecord;
    final theme = Theme.of(context);

    return Card(
      elevation: 5,
      child: Padding(
        padding: const EdgeInsets.all(8.0),
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            Text(
              blocRecord.toString(),
              style: theme.textTheme.bodyLarge,
            ),
            const SizedBox(height: 10),
            Text(
              logRecord.time.toIso8601String().split('T')[1],
              style: theme.textTheme.caption,
            ),
          ],
        ),
      ),
    );
  }
}
